result_mat = [];

algo = {'sum','pinv'} ;

for i = 1:length(algo)
    
    % Construct the set of memory units
    params.aggregator = algo{i};
    params.allocator = allocator;
    params.selector = selector;
    params.data = data;
    
    M = com_new(d, m, Y, params);
    
    hmk = zeros(1, numel(lmk));
    nok = zeros(1, numel(lmk));
    selmk = zeros(1, numel(lmk));  % selectivity
    imk = 1;
    for mk = lmk
        
        [res,nchecked] = com_query(M,Y,Q, mk,params);
        
        switch data
            case 'ukb'
                cur_hmk = eval_ukb( res,gnd,nQ);
            case {'holidays','holidays_flickr1M','oxford5k'}
                [cur_hmk,cur_ap] = compute_map_comu(res,gnd.gnd);
        end
        
        selmk(imk) = (nchecked / (nQ * nY)) + m/nY;
        hmk(imk) = cur_hmk;
        
        imk = imk+1;
        
        disp([selmk ; lmk ; hmk ]);
        
    end
    
    
    disp([selmk ; lmk ; hmk ]);
    
    switch params.aggregator
        case {'sum'},      ls = 'r';
        case {'pinv'},     ls = 'b';
        case {'gs'},       ls = 'm';
    end
    
    plot (selmk, hmk, ls,'LineWidth',1.5); hold on;
    
end

switch data
    case {'holidays','oxford5k','holidays_flickr1M'}
        
        %Calculate the baseline for holidays
        D = Y' * Q;
        [~, bids] = sort(D,'descend');
        bmap = compute_map(bids,gnd.gnd);
        baseline = bmap;
    case 'ukb'
        %Calculate the baseline for ukb
        D = Y' * Q;
        [~, bids] = sort(D,'descend');
        bids = num2cell(bids,1)';
        
        gnd_cell= cell(length(gnd.gnd),1);
        [gnd_cell{:}] = deal(gnd.gnd.ok);
        
        sc = cellfun( @(c,d) numel(find(ismember(c(1:4),d))),bids,gnd_cell);
        sc = mean(sc);
        baseline = sc;
        
end

plot ([0 1], [baseline baseline], 'k--','LineWidth',1.5); hold on;
xlabel('Complexity Ratio')
ylabel('Performance')
legend('sum','pinv','baseline','Location','SouthEast')